// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package email

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// EmailSenderClient is the client API for EmailSender service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type EmailSenderClient interface {
	SendConfirmationEmail(ctx context.Context, in *User, opts ...grpc.CallOption) (*ConfirmationResponse, error)
}

type emailSenderClient struct {
	cc grpc.ClientConnInterface
}

func NewEmailSenderClient(cc grpc.ClientConnInterface) EmailSenderClient {
	return &emailSenderClient{cc}
}

func (c *emailSenderClient) SendConfirmationEmail(ctx context.Context, in *User, opts ...grpc.CallOption) (*ConfirmationResponse, error) {
	out := new(ConfirmationResponse)
	err := c.cc.Invoke(ctx, "/grpc.EmailSender/SendConfirmationEmail", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// EmailSenderServer is the server API for EmailSender service.
// All implementations must embed UnimplementedEmailSenderServer
// for forward compatibility
type EmailSenderServer interface {
	SendConfirmationEmail(context.Context, *User) (*ConfirmationResponse, error)
	mustEmbedUnimplementedEmailSenderServer()
}

// UnimplementedEmailSenderServer must be embedded to have forward compatible implementations.
type UnimplementedEmailSenderServer struct {
}

func (UnimplementedEmailSenderServer) SendConfirmationEmail(context.Context, *User) (*ConfirmationResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SendConfirmationEmail not implemented")
}
func (UnimplementedEmailSenderServer) mustEmbedUnimplementedEmailSenderServer() {}

// UnsafeEmailSenderServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to EmailSenderServer will
// result in compilation errors.
type UnsafeEmailSenderServer interface {
	mustEmbedUnimplementedEmailSenderServer()
}

func RegisterEmailSenderServer(s grpc.ServiceRegistrar, srv EmailSenderServer) {
	s.RegisterService(&EmailSender_ServiceDesc, srv)
}

func _EmailSender_SendConfirmationEmail_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(User)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(EmailSenderServer).SendConfirmationEmail(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/grpc.EmailSender/SendConfirmationEmail",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(EmailSenderServer).SendConfirmationEmail(ctx, req.(*User))
	}
	return interceptor(ctx, in, info, handler)
}

// EmailSender_ServiceDesc is the grpc.ServiceDesc for EmailSender service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var EmailSender_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "grpc.EmailSender",
	HandlerType: (*EmailSenderServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "SendConfirmationEmail",
			Handler:    _EmailSender_SendConfirmationEmail_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "grpc/emailsender.proto",
}
